var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) if (e.indexOf(p[i]) < 0)
            t[p[i]] = s[p[i]];
    return t;
};
import * as React from "react";
import * as _omit from "lodash.omit";
import * as _includes from "lodash.includes";
import { PureComponent } from "react";
import Grid from '@material-ui/core/Grid';
import FormControlLabel from '@material-ui/core/FormControlLabel';
import Checkbox from '@material-ui/core/Checkbox';
import withStyles from '@material-ui/core/styles/withStyles';
import { commonDefaultProps } from "../utils";
import { compose } from "../utils/funtional";
import { InputLabel } from "../InputText/InputLabel";
import { styles } from "./InputCheck.style";
let InputCheckGroup = class InputCheckGroup extends PureComponent {
    constructor() {
        super(...arguments);
        this.renderCheckInputs = () => {
            const _a = _omit(this.props, [
                "className",
                "columns",
                "helpText",
                "id",
                "isValid",
                "label",
                "options"
            ]), { classes, name, value } = _a, otherProps = __rest(_a, ["classes", "name", "value"]);
            return this.props.options.map(option => (React.createElement("div", { key: option },
                React.createElement(FormControlLabel, Object.assign({ classes: {
                        root: classes.root,
                        label: classes.label
                    }, checked: _includes(value, option), name: name, onlyInput: true, text: option, value: option, onChange: this.handleChange(option), control: React.createElement(Checkbox, { color: "primary" }) }, otherProps)))));
        };
        this.handleChange = (option) => (e) => {
            const checked = e.target.checked;
            const oldValue = this.props.value;
            const newValue = checked
                ? [...oldValue, option]
                : oldValue.reduce((updatedValue, currentOption) => {
                    if (currentOption !== option) {
                        updatedValue.push(currentOption);
                    }
                    return updatedValue;
                }, []);
            this.props.onChange(newValue);
        };
    }
    render() {
        const { columns, helpText, label, name } = _omit(this.props, ["className", "id"]);
        const labelId = `label-for-${name}`;
        return (React.createElement(Grid, { "aria-labelledby": labelId, container: true, className: "form-group", spacing: 0 },
            React.createElement(Grid, { item: true, xs: 12, sm: 3, className: "form-label" },
                React.createElement(InputLabel, { className: "col-form-label" }, label)),
            React.createElement(Grid, { item: true, xs: 12, sm: 9 },
                React.createElement("div", { className: "form-check-group", style: { columnCount: columns } }, this.renderCheckInputs()),
                helpText && (React.createElement("div", { className: "form-control-feedback text-muted" }, helpText)))));
    }
};
InputCheckGroup.defaultProps = Object.assign({}, commonDefaultProps, {
    columns: 1,
    options: [],
    value: [],
    onChange: () => null
});
InputCheckGroup = __decorate([
    compose(withStyles(styles))
], InputCheckGroup);
export { InputCheckGroup };
