import { PureComponent } from 'react';
import { Scrollbars } from 'react-custom-scrollbars';
import { Option } from '../../models';
import { CommonWidgetProps } from '../utils';
export interface MultiSelectPropsChanges extends CommonWidgetProps<HTMLInputElement> {
    value?: any;
    size?: any;
    onChange?: any;
}
export interface MultiSelectProps extends MultiSelectPropsChanges {
    options?: Option[];
    removeButtonOnRightSide?: boolean;
    showRemoveButtonOnlyForLastSelectedValue?: boolean;
    scrollHeight?: number;
    size?: string;
    autosize?: boolean;
    value?: any[];
    onChange?: (value: any[]) => void;
}
interface MultiSelectState {
    added: boolean;
}
export declare class MultiSelect extends PureComponent<MultiSelectProps, MultiSelectState> {
    scrollBars?: Scrollbars;
    static defaultProps: Partial<MultiSelectProps>;
    constructor(props: MultiSelectProps);
    componentDidUpdate(prevProps: MultiSelectProps): void;
    render(): JSX.Element;
    renderInput: () => JSX.Element;
    handleChange: (selectedValue: Option) => void;
    handleRemove: (value: string) => () => void;
    handleOpenMenu: () => void;
    getOptions: () => {
        label: string;
        value: string;
    }[];
}
export {};
